/*
 *		Jiri Skala		A01216
 *
 *		KIV / GSVD		2004/05
 *
 *		INTERNAL TESTING MODULE SETUP DIALOG
 */
using System;

namespace Zcu.Gsvd.DisplaceMap.Testing
{
	/// <summary>
	/// <i>RegGrid2DSource</i> module setup dialog.
	/// </summary>
	public class RegGrid2DSourceSetup : Zcu.Mve.Core.ModuleSetup
	{
		#region Frame components

		private System.Windows.Forms.NumericUpDown numUpDnWidth;
		private System.Windows.Forms.NumericUpDown numUpDnHeight;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.TextBox textBoxCellColor;
		private System.Windows.Forms.CheckBox checkBoxCellColor;
		private System.Windows.Forms.CheckBox checkBoxPointScalar;
		private System.Windows.Forms.TextBox textBoxPointScalar;
		private System.Windows.Forms.CheckBox checkBoxPointColor;
		private System.Windows.Forms.TextBox textBoxPointColor;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.CheckBox checkBoxCellScalar;
		private System.Windows.Forms.TextBox textBoxCellScalar;
		private System.Windows.Forms.Label label6;

		#endregion

		/// <summary>
		/// Reference to module which we set up.
		/// </summary>
		private RegGrid2DSource parentModule;

		/// <summary>
		/// Constructor. Initializes GUI and stores parent module reference.
		/// </summary>
		/// <param name="parentModule">Parent module reference.</param>
		public RegGrid2DSourceSetup(RegGrid2DSource parentModule)
		{
			// Required for Windows Form Designer support
			InitializeComponent();

			// store parent module reference
			this.parentModule = parentModule;

			// load module setup
			numUpDnWidth.Value = parentModule.Width;
			numUpDnHeight.Value = parentModule.Height;
			bool assign;
			textBoxCellColor.Text = parentModule.GetCellColorName(out assign);
			checkBoxCellColor.Checked = assign;
			textBoxCellScalar.Text = parentModule.GetCellScalarName(out assign);
			checkBoxCellScalar.Checked = assign;
			textBoxPointColor.Text = parentModule.GetPointColorName(out assign);
			checkBoxPointColor.Checked = assign;
			textBoxPointScalar.Text = parentModule.GetPointScalarName(out assign);
			checkBoxPointScalar.Checked = assign;
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.numUpDnWidth = new System.Windows.Forms.NumericUpDown();
			this.numUpDnHeight = new System.Windows.Forms.NumericUpDown();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.textBoxCellColor = new System.Windows.Forms.TextBox();
			this.checkBoxCellColor = new System.Windows.Forms.CheckBox();
			this.checkBoxPointScalar = new System.Windows.Forms.CheckBox();
			this.textBoxPointScalar = new System.Windows.Forms.TextBox();
			this.label4 = new System.Windows.Forms.Label();
			this.checkBoxPointColor = new System.Windows.Forms.CheckBox();
			this.textBoxPointColor = new System.Windows.Forms.TextBox();
			this.label5 = new System.Windows.Forms.Label();
			this.checkBoxCellScalar = new System.Windows.Forms.CheckBox();
			this.textBoxCellScalar = new System.Windows.Forms.TextBox();
			this.label6 = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.numUpDnWidth)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numUpDnHeight)).BeginInit();
			this.SuspendLayout();
			// 
			// numUpDnWidth
			// 
			this.numUpDnWidth.Location = new System.Drawing.Point(120, 8);
			this.numUpDnWidth.Maximum = new System.Decimal(new int[] {
																		 20,
																		 0,
																		 0,
																		 0});
			this.numUpDnWidth.Name = "numUpDnWidth";
			this.numUpDnWidth.Size = new System.Drawing.Size(56, 20);
			this.numUpDnWidth.TabIndex = 0;
			// 
			// numUpDnHeight
			// 
			this.numUpDnHeight.Location = new System.Drawing.Point(120, 32);
			this.numUpDnHeight.Maximum = new System.Decimal(new int[] {
																		  20,
																		  0,
																		  0,
																		  0});
			this.numUpDnHeight.Name = "numUpDnHeight";
			this.numUpDnHeight.Size = new System.Drawing.Size(56, 20);
			this.numUpDnHeight.TabIndex = 1;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(104, 23);
			this.label1.TabIndex = 2;
			this.label1.Text = "Width (no. of cells)";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 32);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(104, 23);
			this.label2.TabIndex = 3;
			this.label2.Text = "Height (no. of cells)";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(8, 64);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(96, 23);
			this.label3.TabIndex = 4;
			this.label3.Text = "Cell color attribute";
			this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// textBoxCellColor
			// 
			this.textBoxCellColor.Location = new System.Drawing.Point(8, 88);
			this.textBoxCellColor.Name = "textBoxCellColor";
			this.textBoxCellColor.TabIndex = 5;
			this.textBoxCellColor.Text = "textBox1";
			// 
			// checkBoxCellColor
			// 
			this.checkBoxCellColor.Location = new System.Drawing.Point(120, 88);
			this.checkBoxCellColor.Name = "checkBoxCellColor";
			this.checkBoxCellColor.Size = new System.Drawing.Size(64, 24);
			this.checkBoxCellColor.TabIndex = 6;
			this.checkBoxCellColor.Text = "Assign";
			// 
			// checkBoxPointScalar
			// 
			this.checkBoxPointScalar.Location = new System.Drawing.Point(120, 240);
			this.checkBoxPointScalar.Name = "checkBoxPointScalar";
			this.checkBoxPointScalar.Size = new System.Drawing.Size(64, 24);
			this.checkBoxPointScalar.TabIndex = 9;
			this.checkBoxPointScalar.Text = "Assign";
			// 
			// textBoxPointScalar
			// 
			this.textBoxPointScalar.Location = new System.Drawing.Point(8, 240);
			this.textBoxPointScalar.Name = "textBoxPointScalar";
			this.textBoxPointScalar.TabIndex = 8;
			this.textBoxPointScalar.Text = "textBox4";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(8, 216);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(112, 23);
			this.label4.TabIndex = 7;
			this.label4.Text = "Point scalar attribute";
			this.label4.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// checkBoxPointColor
			// 
			this.checkBoxPointColor.Location = new System.Drawing.Point(120, 192);
			this.checkBoxPointColor.Name = "checkBoxPointColor";
			this.checkBoxPointColor.Size = new System.Drawing.Size(64, 24);
			this.checkBoxPointColor.TabIndex = 15;
			this.checkBoxPointColor.Text = "Assign";
			// 
			// textBoxPointColor
			// 
			this.textBoxPointColor.Location = new System.Drawing.Point(8, 192);
			this.textBoxPointColor.Name = "textBoxPointColor";
			this.textBoxPointColor.TabIndex = 14;
			this.textBoxPointColor.Text = "textBox3";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(8, 168);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(112, 23);
			this.label5.TabIndex = 13;
			this.label5.Text = "Point color attribute";
			this.label5.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// checkBoxCellScalar
			// 
			this.checkBoxCellScalar.Location = new System.Drawing.Point(120, 136);
			this.checkBoxCellScalar.Name = "checkBoxCellScalar";
			this.checkBoxCellScalar.Size = new System.Drawing.Size(64, 24);
			this.checkBoxCellScalar.TabIndex = 12;
			this.checkBoxCellScalar.Text = "Assign";
			// 
			// textBoxCellScalar
			// 
			this.textBoxCellScalar.Location = new System.Drawing.Point(8, 136);
			this.textBoxCellScalar.Name = "textBoxCellScalar";
			this.textBoxCellScalar.TabIndex = 11;
			this.textBoxCellScalar.Text = "textBox2";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(8, 112);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(104, 23);
			this.label6.TabIndex = 10;
			this.label6.Text = "Cell scalar attribute";
			this.label6.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// RegGrid2DSourceSetup
			// 
			this.Controls.Add(this.checkBoxPointColor);
			this.Controls.Add(this.textBoxPointColor);
			this.Controls.Add(this.label5);
			this.Controls.Add(this.checkBoxCellScalar);
			this.Controls.Add(this.textBoxCellScalar);
			this.Controls.Add(this.label6);
			this.Controls.Add(this.checkBoxPointScalar);
			this.Controls.Add(this.textBoxPointScalar);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.checkBoxCellColor);
			this.Controls.Add(this.textBoxCellColor);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.numUpDnHeight);
			this.Controls.Add(this.numUpDnWidth);
			this.Name = "RegGrid2DSourceSetup";
			this.Size = new System.Drawing.Size(192, 272);
			((System.ComponentModel.ISupportInitialize)(this.numUpDnWidth)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numUpDnHeight)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Accepts changes and performs parent module setup.
		/// </summary>
		/// <returns>Returns true if setup is correct. Otherwise returns false.</returns>
		public override bool OnOkClick()
		{
			// set parent module up
			parentModule.Width = (int)numUpDnWidth.Value;
			parentModule.Height = (int)numUpDnHeight.Value;
			parentModule.SetCellColorName(textBoxCellColor.Text, checkBoxCellColor.Checked);
			parentModule.SetCellScalarName(textBoxCellScalar.Text, checkBoxCellScalar.Checked);
			parentModule.SetPointColorName(textBoxPointColor.Text, checkBoxPointColor.Checked);
			parentModule.SetPointScalarName(textBoxPointScalar.Text, checkBoxPointScalar.Checked);

			return true;
		}
	}
}