/*
 *		Jiri Skala		A01216
 *
 *		KIV / GSVD		2004/05
 *
 *		INTERNAL TESTING MODULE SETUP DIALOG
 */
using System;

namespace Zcu.Gsvd.DisplaceMap.Testing
{
	/// <summary>
	/// Summary description for TriMeshAttrAdderSetup.
	/// </summary>
	public class TriMeshAttrAdderSetup : Zcu.Mve.Core.ModuleSetup
	{
		#region Frame components

		private System.Windows.Forms.CheckBox checkBoxScalar;
		private System.Windows.Forms.TextBox textBoxScalar;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.CheckBox checkBoxColor;
		private System.Windows.Forms.TextBox textBoxColor;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.CheckBox checkBoxPlanar;

		#endregion

		/// <summary>
		/// Reference to module which we set up.
		/// </summary>
		private TriMeshAttrAdder parentModule;

		/// <summary>
		/// Constructor. Initializes GUI and stores parent module reference.
		/// </summary>
		/// <param name="parentModule">Parent module reference.</param>
		public TriMeshAttrAdderSetup(TriMeshAttrAdder parentModule)
		{
			// Required for Windows Form Designer support
			InitializeComponent();

			// store parent module reference
			this.parentModule = parentModule;

			// load module setup
			checkBoxPlanar.Checked = parentModule.MakePlanar;
			bool assign;
			textBoxColor.Text = parentModule.GetPointColorName(out assign);
			checkBoxColor.Checked = assign;
			textBoxScalar.Text = parentModule.GetPointScalarName(out assign);
			checkBoxScalar.Checked = assign;
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.checkBoxScalar = new System.Windows.Forms.CheckBox();
			this.textBoxScalar = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.checkBoxColor = new System.Windows.Forms.CheckBox();
			this.textBoxColor = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.checkBoxPlanar = new System.Windows.Forms.CheckBox();
			this.SuspendLayout();
			// 
			// checkBoxScalar
			// 
			this.checkBoxScalar.Location = new System.Drawing.Point(120, 120);
			this.checkBoxScalar.Name = "checkBoxScalar";
			this.checkBoxScalar.Size = new System.Drawing.Size(64, 24);
			this.checkBoxScalar.TabIndex = 15;
			this.checkBoxScalar.Text = "Assign";
			// 
			// textBoxScalar
			// 
			this.textBoxScalar.Location = new System.Drawing.Point(8, 120);
			this.textBoxScalar.Name = "textBoxScalar";
			this.textBoxScalar.TabIndex = 14;
			this.textBoxScalar.Text = "textBox2";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 96);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(112, 23);
			this.label2.TabIndex = 13;
			this.label2.Text = "Point scalar attribute";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// checkBoxColor
			// 
			this.checkBoxColor.Location = new System.Drawing.Point(120, 64);
			this.checkBoxColor.Name = "checkBoxColor";
			this.checkBoxColor.Size = new System.Drawing.Size(64, 24);
			this.checkBoxColor.TabIndex = 12;
			this.checkBoxColor.Text = "Assign";
			// 
			// textBoxColor
			// 
			this.textBoxColor.Location = new System.Drawing.Point(8, 64);
			this.textBoxColor.Name = "textBoxColor";
			this.textBoxColor.TabIndex = 11;
			this.textBoxColor.Text = "textBox1";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 40);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(104, 23);
			this.label1.TabIndex = 10;
			this.label1.Text = "Point color attribute";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// checkBoxPlanar
			// 
			this.checkBoxPlanar.Location = new System.Drawing.Point(8, 8);
			this.checkBoxPlanar.Name = "checkBoxPlanar";
			this.checkBoxPlanar.Size = new System.Drawing.Size(144, 24);
			this.checkBoxPlanar.TabIndex = 16;
			this.checkBoxPlanar.Text = "Convert 3D mesh to 2D";
			// 
			// TriMeshAttrAdderSetup
			// 
			this.Controls.Add(this.checkBoxPlanar);
			this.Controls.Add(this.checkBoxScalar);
			this.Controls.Add(this.textBoxScalar);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.checkBoxColor);
			this.Controls.Add(this.textBoxColor);
			this.Controls.Add(this.label1);
			this.Name = "TriMeshAttrAdderSetup";
			this.Size = new System.Drawing.Size(192, 152);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Accepts changes and performs parent module setup.
		/// </summary>
		/// <returns>Returns true if setup is correct. Otherwise returns false.</returns>
		public override bool OnOkClick()
		{
			// set parent module up
			parentModule.MakePlanar = checkBoxPlanar.Checked;
			parentModule.SetPointColorName(textBoxColor.Text, checkBoxColor.Checked);
			parentModule.SetPointScalarName(textBoxScalar.Text, checkBoxScalar.Checked);

			return true;
		}
	}
}